---
title: Create a monitor
description: Create a monitor using the specified options.
breadcrumbs: Docs > API > Create a monitor
---

> For the complete documentation index, see [llms.txt](https://docs.datadoghq.com/llms.txt).

# Create a monitor

## v1 (latest)

| Datadog site      | API endpoint                                      |
| ----------------- | ------------------------------------------------- |
| app.datadoghq.com | POST https://api.datadoghq.com/api/v1/monitor     |
| us3.datadoghq.com | POST https://api.us3.datadoghq.com/api/v1/monitor |
| us5.datadoghq.com | POST https://api.us5.datadoghq.com/api/v1/monitor |
| app.datadoghq.eu  | POST https://api.datadoghq.eu/api/v1/monitor      |
| ap1.datadoghq.com | POST https://api.ap1.datadoghq.com/api/v1/monitor |
| ap2.datadoghq.com | POST https://api.ap2.datadoghq.com/api/v1/monitor |
| uk1.datadoghq.com | POST https://api.uk1.datadoghq.com/api/v1/monitor |
| app.ddog-gov.com  | POST https://api.ddog-gov.com/api/v1/monitor      |
| us2.ddog-gov.com  | POST https://api.us2.ddog-gov.com/api/v1/monitor  |

### Overview

Create a monitor using the specified options.

#### Monitor Types

The type of monitor chosen from:

- anomaly: `query alert`
- APM: `query alert` or `trace-analytics alert`
- composite: `composite`
- custom: `service check`
- forecast: `query alert`
- host: `service check`
- integration: `query alert` or `service check`
- live process: `process alert`
- logs: `log alert`
- metric: `query alert`
- network: `service check`
- outlier: `query alert`
- process: `service check`
- rum: `rum alert`
- SLO: `slo alert`
- watchdog: `event-v2 alert`
- event-v2: `event-v2 alert`
- audit: `audit alert`
- error-tracking: `error-tracking alert`
- database-monitoring: `database-monitoring alert`
- network-performance: `network-performance alert`
- cloud cost: `cost alert`
- network-path: `network-path alert`

**Notes**:

- Synthetic monitors are created through the Synthetics API. See the [Synthetics API](https://docs.datadoghq.com/api/latest/synthetics.md) documentation for more information.
- Log monitors require an unscoped App Key.

#### Query Types

##### Metric Alert Query

Example: `time_aggr(time_window):space_aggr:metric{tags} [by {key}] operator #`

- `time_aggr`: avg, sum, max, min, change, or pct_change
- `time_window`: `last_#m` (with `#` between 1 and 10080 depending on the monitor type) or `last_#h`(with `#` between 1 and 168 depending on the monitor type) or `last_1d`, or `last_1w`
- `space_aggr`: avg, sum, min, or max
- `tags`: one or more tags (comma-separated), or *
- `key`: a 'key' in key:value tag syntax; defines a separate alert for each tag in the group (multi-alert)
- `operator`: <, <=, >, >=, ==, or !=
- `#`: an integer or decimal number used to set the threshold

To use a dynamic threshold on a metric monitor with a formula query, replace `#` with the `threshold` keyword
(for example, `... > threshold`) and provide the threshold as a query via `critical_query` on `options.thresholds`.
This feature is in preview.

If you are using the `_change_` or `_pct_change_` time aggregator, instead use `change_aggr(time_aggr(time_window), timeshift):space_aggr:metric{tags} [by {key}] operator #` with:

- `change_aggr` change, pct_change
- `time_aggr` avg, sum, max, min [Learn more](https://docs.datadoghq.com/monitors/create/types.md#define-the-conditions)
- `time_window` last_#m (between 1 and 2880 depending on the monitor type), last_#h (between 1 and 48 depending on the monitor type), or last_#d (1 or 2)
- `timeshift` #m_ago (5, 10, 15, or 30), #h_ago (1, 2, or 4), or 1d_ago

Use this to create an outlier monitor using the following query:
`avg(last_30m):outliers(avg:system.cpu.user{role:es-events-data} by {host}, 'dbscan', 7) > 0`

##### Service Check Query

Example: `"check".over(tags).last(count).by(group).count_by_status()`

- `check` name of the check, for example `datadog.agent.up`
- `tags` one or more quoted tags (comma-separated), or "*". for example: `.over("env:prod", "role:db")`; `over` cannot be blank.
- `count` must be at greater than or equal to your max threshold (defined in the `options`). It is limited to 100.
  For example, if you've specified to notify on 1 critical, 3 ok, and 2 warn statuses, `count` should be at least 3.
- `group` must be specified for check monitors. Per-check grouping is already explicitly known for some service checks.
  For example, Postgres integration monitors are tagged by `db`, `host`, and `port`, and Network monitors by `host`, `instance`, and `url`. See [Service Checks](https://docs.datadoghq.com/api/latest/service-checks.md) documentation for more information.

##### Event Alert Query

**Note:** The Event Alert Query has been replaced by the Event V2 Alert Query. For more information, see the [Event Migration guide](https://docs.datadoghq.com/service_management/events/guides/migrating_to_new_events_features.md).

##### Event V2 Alert Query

Example: `events(query).rollup(rollup_method[, measure]).last(time_window) operator #`

- `query` The search query - following the [Log search syntax](https://docs.datadoghq.com/logs/search_syntax.md).
- `rollup_method` The stats roll-up method - supports `count`, `avg` and `cardinality`.
- `measure` For `avg` and cardinality `rollup_method` - specify the measure or the facet name you want to use.
- `time_window` #m (between 1 and 2880), #h (between 1 and 48).
- `operator` `<`, `<=`, `>`, `>=`, `==`, or `!=`.
- `#` an integer or decimal number used to set the threshold.

##### Process Alert Query

Example: `processes(search).over(tags).rollup('count').last(timeframe) operator #`

- `search` free text search string for querying processes.
  Matching processes match results on the [Live Processes](https://docs.datadoghq.com/infrastructure/process.md?tab=linuxwindows) page.
- `tags` one or more tags (comma-separated)
- `timeframe` the timeframe to roll up the counts. Examples: 10m, 4h. Supported timeframes: s, m, h and d
- `operator` <, <=, >, >=, ==, or !=
- `#` an integer or decimal number used to set the threshold

##### Logs Alert Query

Example: `logs(query).index(index_name).rollup(rollup_method[, measure]).last(time_window) operator #`

- `query` The search query - following the [Log search syntax](https://docs.datadoghq.com/logs/search_syntax.md).
- `index_name` For multi-index organizations, the log index in which the request is performed.
- `rollup_method` The stats roll-up method - supports `count`, `avg` and `cardinality`.
- `measure` For `avg` and cardinality `rollup_method` - specify the measure or the facet name you want to use.
- `time_window` #m (between 1 and 2880), #h (between 1 and 48).
- `operator` `<`, `<=`, `>`, `>=`, `==`, or `!=`.
- `#` an integer or decimal number used to set the threshold.

##### Composite Query

Example: `12345 && 67890`, where `12345` and `67890` are the IDs of non-composite monitors

* `name` [*required*, *default* = **dynamic, based on query**]: The name of the alert.
* `message` [*required*, *default* = **dynamic, based on query**]: A message to include with notifications for this monitor.
  Email notifications can be sent to specific users by using the same '@username' notation as events.
* `tags` [*optional*, *default* = **empty list**]: A list of tags to associate with your monitor.
  When getting all monitor details via the API, use the `monitor_tags` argument to filter results by these tags.
  It is only available via the API and isn't visible or editable in the Datadog UI.

##### SLO Alert Query

Example: `error_budget("slo_id").over("time_window") operator #`

- `slo_id`: The alphanumeric SLO ID of the SLO you are configuring the alert for.
- `time_window`: The time window of the SLO target you wish to alert on. Valid options: `7d`, `30d`, `90d`.
- `operator`: `>=` or `>`

##### Audit Alert Query

Example: `audits(query).rollup(rollup_method[, measure]).last(time_window) operator #`

- `query` The search query - following the [Log search syntax](https://docs.datadoghq.com/logs/search_syntax.md).
- `rollup_method` The stats roll-up method - supports `count`, `avg` and `cardinality`.
- `measure` For `avg` and cardinality `rollup_method` - specify the measure or the facet name you want to use.
- `time_window` #m (between 1 and 2880), #h (between 1 and 48).
- `operator` `<`, `<=`, `>`, `>=`, `==`, or `!=`.
- `#` an integer or decimal number used to set the threshold.

##### CI Pipelines Alert Query

Example: `ci-pipelines(query).rollup(rollup_method[, measure]).last(time_window) operator #`

- `query` The search query - following the [Log search syntax](https://docs.datadoghq.com/logs/search_syntax.md).
- `rollup_method` The stats roll-up method - supports `count`, `avg`, and `cardinality`.
- `measure` For `avg` and cardinality `rollup_method` - specify the measure or the facet name you want to use.
- `time_window` #m (between 1 and 2880), #h (between 1 and 48).
- `operator` `<`, `<=`, `>`, `>=`, `==`, or `!=`.
- `#` an integer or decimal number used to set the threshold.

##### CI Tests Alert Query

Example: `ci-tests(query).rollup(rollup_method[, measure]).last(time_window) operator #`

- `query` The search query - following the [Log search syntax](https://docs.datadoghq.com/logs/search_syntax.md).
- `rollup_method` The stats roll-up method - supports `count`, `avg`, and `cardinality`.
- `measure` For `avg` and cardinality `rollup_method` - specify the measure or the facet name you want to use.
- `time_window` #m (between 1 and 2880), #h (between 1 and 48).
- `operator` `<`, `<=`, `>`, `>=`, `==`, or `!=`.
- `#` an integer or decimal number used to set the threshold.

##### Error Tracking Alert Query

"New issue" example: `error-tracking(query).source(issue_source).new().rollup(rollup_method[, measure]).by(group_by).last(time_window) operator #`
"High impact issue" example: `error-tracking(query).source(issue_source).impact().rollup(rollup_method[, measure]).by(group_by).last(time_window) operator #`

- `query` The search query - following the [Log search syntax](https://docs.datadoghq.com/logs/search_syntax.md).
- `issue_source` The issue source - supports `all`, `browser`, `mobile` and `backend` and defaults to `all` if omitted.
- `rollup_method` The stats roll-up method - supports `count`, `avg`, and `cardinality` and defaults to `count` if omitted.
- `measure` For `avg` and cardinality `rollup_method` - specify the measure or the facet name you want to use.
- `group by` Comma-separated list of attributes to group by - should contain at least `issue.id`.
- `time_window` #m (between 1 and 2880), #h (between 1 and 48).
- `operator` `<`, `<=`, `>`, `>=`, `==`, or `!=`.
- `#` an integer or decimal number used to set the threshold.

**Database Monitoring Alert Query**

Example: `database-monitoring(query).rollup(rollup_method[, measure]).last(time_window) operator #`

- `query` The search query - following the [Log search syntax](https://docs.datadoghq.com/logs/search_syntax.md).
- `rollup_method` The stats roll-up method - supports `count`, `avg`, and `cardinality`.
- `measure` For `avg` and cardinality `rollup_method` - specify the measure or the facet name you want to use.
- `time_window` #m (between 1 and 2880), #h (between 1 and 48).
- `operator` `<`, `<=`, `>`, `>=`, `==`, or `!=`.
- `#` an integer or decimal number used to set the threshold.

**Network Performance Alert Query**

Example: `network-performance(query).rollup(rollup_method[, measure]).last(time_window) operator #`

- `query` The search query - following the [Log search syntax](https://docs.datadoghq.com/logs/search_syntax.md).
- `rollup_method` The stats roll-up method - supports `count`, `avg`, and `cardinality`.
- `measure` For `avg` and cardinality `rollup_method` - specify the measure or the facet name you want to use.
- `time_window` #m (between 1 and 2880), #h (between 1 and 48).
- `operator` `<`, `<=`, `>`, `>=`, `==`, or `!=`.
- `#` an integer or decimal number used to set the threshold.

**Cost Alert Query**

Example: `formula(query).timeframe_type(time_window).function(parameter) operator #`

- `query` The search query - following the [Log search syntax](https://docs.datadoghq.com/logs/search_syntax.md).
- `timeframe_type` The timeframe type to evaluate the cost
  - for `forecast` supports `current`
  - for `change`, `anomaly`, `threshold` supports `last`
- `time_window` - supports daily roll-up e.g. `7d`
- `function` - [optional, defaults to `threshold` monitor if omitted] supports `change`, `anomaly`, `forecast`
- `parameter` Specify the parameter of the type
  - for `change`:
    - supports `relative`, `absolute`
    - [optional] supports `#`, where `#` is an integer or decimal number used to set the threshold
  - for `anomaly`:
    - supports `direction=both`, `direction=above`, `direction=below`
    - [optional] supports `threshold=#`, where `#` is an integer or decimal number used to set the threshold
- `operator`
  - for `threshold` supports `<`, `<=`, `>`, `>=`, `==`, or `!=`
  - for `change` supports `>`, `<`
  - for `anomaly` supports `>=`
  - for `forecast` supports `>`
- `#` an integer or decimal number used to set the threshold.

**Network Path Alert Query**

Example: `network-path(query).index(index_name).rollup(rollup_method[, measure]).last(time_window) operator #`

- `query` The search query - following the [Log search syntax](https://docs.datadoghq.com/logs/search_syntax.md).
- `index_name` The data type to monitor on - supports `netpath-path` and `netpath-hop`.
- `rollup_method` The stats roll-up method - supports `count`, `avg`, and `cardinality`.
- `measure` For `avg` and cardinality `rollup_method` - specify the measure or the facet name you want to use.
- `time_window` #m (between 1 and 2880), #h (between 1 and 48).
- `operator` `<`, `<=`, `>`, `>=`, `==`, or `!=`.
- `#` an integer or decimal number used to set the threshold.

**Data Jobs Alert Query**

Job status example: `formula("failed_runs(run_query)").by(group_keys).last(time_window) > #`

Job duration examples: `formula("job_duration(run_query)").detection(static).by(group_keys) > duration`
and `formula("job_duration(run_query)").detection(anomaly).by(group_keys) > 0`

- `run_query`: The name of the single query variable in `options.variables`. Job status monitors
  use a data jobs query; job duration monitors use a data quality query with the `duration` measure.
- `group_keys`: The tags to group by, such as `entity_id,name,workspace_name`.
- `time_window`: Number of minutes (#m), hours (#h), or days (#d), up to `10d`.
- `#`: The number of trailing failed runs to alert above, as a non-negative integer.
- `duration`: The duration to alert above, such as `2h`, `30m`, or a number of seconds.
- `options.thresholds.critical`: Must equal the query threshold, in seconds for job duration.
  Anomaly job duration monitors omit `options.thresholds`.

This endpoint requires any of the following permissions:

- `monitors_write`
- `monitors_draft_write`

OAuth apps require one of the following authorization [scopes](https://docs.datadoghq.com/api/latest/scopes.md#monitors) to access this endpoint: `monitors_write`, `monitors_draft_write`.

### Request

#### Body Data (required)

Create a monitor request body.

{% tabs %}
{% tab label="Model" %}
| Parent field                  | Field                          | Type      | Description                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     |
| ----------------------------- | ------------------------------ | --------- | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
|                               | assets                         | [object]  | The list of monitor assets tied to a monitor, which represents key links for users to take action on monitor alerts (for example, runbooks).                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    |
| assets                        | category [*required*]          | enum      | Indicates the type of asset this entity represents on a monitor. Allowed enum values: `runbook`.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                |
| assets                        | name [*required*]              | string    | Name for the monitor asset                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      |
| assets                        | resource_key                   | string    | Represents the identifier of the internal Datadog resource that this asset represents. IDs in this field should be passed in as strings.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        |
| assets                        | resource_type                  | enum      | Type of internal Datadog resource associated with a monitor asset. Allowed enum values: `notebook`.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             |
| assets                        | url [*required*]               | string    | URL link for the asset. For links with an internal resource type set, this should be the relative path to where the Datadog domain is appended internally. For external links, this should be the full URL path.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                |
|                               | draft_status                   | enum      | Indicates whether the monitor is in a draft or published state. `draft`: The monitor appears as Draft and does not send notifications. `published`: The monitor is active and evaluates conditions and notify as configured. This field is in preview. The draft value is only available to customers with the feature enabled. Allowed enum values: `draft`, `published`. Default: `published`.                                                                                                                                                                                                                                                                                                                                                |
|                               | matching_downtimes             | [object]  | A list of active v1 downtimes that match this monitor.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          |
| matching_downtimes            | end                            | int64     | POSIX timestamp to end the downtime.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            |
| matching_downtimes            | scope                          | [string]  | The scope(s) to which the downtime applies. Must be in `key:value` format. For example, `host:app2`. Provide multiple scopes as a comma-separated list like `env:dev,env:prod`. The resulting downtime applies to sources that matches ALL provided scopes (`env:dev` **AND** `env:prod`).                                                                                                                                                                                                                                                                                                                                                                                                                                                      |
| matching_downtimes            | start                          | int64     | POSIX timestamp to start the downtime.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          |
|                               | message                        | string    | A message to include with notifications for this monitor.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       |
|                               | name                           | string    | The monitor name.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               |
|                               | options                        | object    | List of options associated with your monitor.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   |
| options                       | enable_logs_sample             | boolean   | Whether or not to send a log sample when the log monitor triggers.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              |
| options                       | enable_samples                 | boolean   | Whether or not to send a list of samples when the monitor triggers. This is only used by CI Test and Pipeline monitors.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         |
| options                       | escalation_message             | string    | We recommend using the [is_renotify](https://docs.datadoghq.com/monitors/notify.md?tab=is_alert#renotify), block in the original message instead. A message to include with a re-notification. Supports the `@username` notification we allow elsewhere. Not applicable if `renotify_interval` is `None`.                                                                                                                                                                                                                                                                                                                                                                                                                                       |
| options                       | evaluation_delay               | int64     | Time (in seconds) to delay evaluation, as a non-negative integer. For example, if the value is set to `300` (5min), the timeframe is set to `last_5m` and the time is 7:00, the monitor evaluates data from 6:50 to 6:55. This is useful for AWS CloudWatch and other backfilled metrics to ensure the monitor always has data during evaluation.                                                                                                                                                                                                                                                                                                                                                                                               |
| options                       | group_retention_duration       | string    | The time span after which groups with missing data are dropped from the monitor state. The minimum value is one hour, and the maximum value is 72 hours. Example values are: "60m", "1h", and "2d". This option is only available for APM Trace Analytics, Audit Trail, CI, Error Tracking, Event, Logs, and RUM monitors.                                                                                                                                                                                                                                                                                                                                                                                                                      |
| options                       | groupby_simple_monitor         | boolean   | **DEPRECATED**: Whether the log alert monitor triggers a single alert or multiple alerts when any group breaches a threshold. Use `notify_by` instead.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          |
| options                       | include_tags                   | boolean   | A Boolean indicating whether notifications from this monitor automatically inserts its triggering tags into the title. **Examples** - If `True`, `[Triggered on {host:h1}] Monitor Title` - If `False`, `[Triggered] Monitor Title` Default: `true`.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            |
| options                       | locked                         | boolean   | **DEPRECATED**: Whether or not the monitor is locked (only editable by creator and admins). Use `restricted_roles` instead.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     |
| options                       | min_failure_duration           | int64     | How long the test should be in failure before alerting (integer, number of seconds, max 7200). Default: `0`.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    |
| options                       | min_location_failed            | int64     | The minimum number of locations in failure at the same time during at least one moment in the `min_failure_duration` period (`min_location_failed` and `min_failure_duration` are part of the advanced alerting rules - integer, >= 1). Default: `1`.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           |
| options                       | new_group_delay                | int64     | Time (in seconds) to skip evaluations for new groups. For example, this option can be used to skip evaluations for new hosts while they initialize. Must be a non negative integer.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             |
| options                       | new_host_delay                 | int64     | **DEPRECATED**: Time (in seconds) to allow a host to boot and applications to fully start before starting the evaluation of monitor results. Should be a non negative integer. Use new_group_delay instead. Default: `300`.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     |
| options                       | no_data_timeframe              | int64     | The number of minutes before a monitor notifies after data stops reporting. Datadog recommends at least 2x the monitor timeframe for query alerts or 2 minutes for service checks. If omitted, 2x the evaluation timeframe is used for query alerts, and 24 hours is used for service checks.                                                                                                                                                                                                                                                                                                                                                                                                                                                   |
| options                       | notification_preset_name       | enum      | Toggles the display of additional content sent in the monitor notification. Allowed enum values: `show_all`, `hide_query`, `hide_handles`, `hide_all`, `hide_query_and_handles`, `show_only_snapshot`, `hide_handles_and_footer`. Default: `show_all`.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          |
| options                       | notify_audit                   | boolean   | A Boolean indicating whether tagged users is notified on changes to this monitor. Default: `false`.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             |
| options                       | notify_by                      | [string]  | Controls what granularity a monitor alerts on. Only available for monitors with groupings. For instance, a monitor grouped by `cluster`, `namespace`, and `pod` can be configured to only notify on each new `cluster` violating the alert conditions by setting `notify_by` to `["cluster"]`. Tags mentioned in `notify_by` must be a subset of the grouping tags in the query. For example, a query grouped by `cluster` and `namespace` cannot notify on `region`. Setting `notify_by` to `["*"]` configures the monitor to notify as a simple-alert.                                                                                                                                                                                        |
| options                       | notify_no_data                 | boolean   | A Boolean indicating whether this monitor notifies when data stops reporting. Defaults to `false`.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              |
| options                       | on_missing_data                | enum      | Controls how groups or monitors are treated if an evaluation does not return any data points. The default option results in different behavior depending on the monitor query type. For monitors using Count queries, an empty monitor evaluation is treated as 0 and is compared to the threshold conditions. For monitors using any query type other than Count, for example Gauge, Measure, or Rate, the monitor shows the last known status. This option is available for APM Trace Analytics, Audit Trail, CI, Error Tracking, Event, Logs, and RUM monitors. It is also required for metric monitors that use `scheduling_options.custom_schedule`. Allowed enum values: `default`, `show_no_data`, `show_and_notify_no_data`, `resolve`. |
| options                       | renotify_interval              | int64     | The number of minutes after the last notification before a monitor re-notifies on the current status. It only re-notifies if it’s not resolved. Default: `null`.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                |
| options                       | renotify_occurrences           | int64     | The number of times re-notification messages should be sent on the current status at the provided re-notification interval.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     |
| options                       | renotify_statuses              | [string]  | The types of monitor statuses for which re-notification messages are sent. Default: **null** if `renotify_interval` is **null**. If `renotify_interval` is set, defaults to renotify on `Alert` and `No Data`.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  |
| options                       | require_full_window            | boolean   | A Boolean indicating whether this monitor needs a full window of data before it’s evaluated. We highly recommend you set this to `false` for sparse metrics, otherwise some evaluations are skipped. Default is false. This setting only applies to metric monitors.                                                                                                                                                                                                                                                                                                                                                                                                                                                                            |
| options                       | scheduling_options             | object    | Configuration options for scheduling.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           |
| scheduling_options            | custom_schedule                | object    | Configuration options for the custom schedule. **This feature is in private beta.**                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             |
| custom_schedule               | recurrences                    | [object]  | Array of custom schedule recurrences.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           |
| recurrences                   | rrule                          | string    | Defines the recurrence rule (RRULE) for a given schedule.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       |
| recurrences                   | start                          | string    | Defines the start date and time of the recurring schedule.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      |
| recurrences                   | timezone                       | string    | Defines the timezone the schedule runs on.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      |
| scheduling_options            | evaluation_window              | object    | Configuration options for the evaluation window. If `hour_starts` is set, no other fields may be set. Otherwise, `day_starts` and `month_starts` must be set together.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          |
| evaluation_window             | day_starts                     | string    | The time of the day at which a one day cumulative evaluation window starts.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     |
| evaluation_window             | hour_starts                    | int32     | The minute of the hour at which a one hour cumulative evaluation window starts.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 |
| evaluation_window             | month_starts                   | int32     | The day of the month at which a one month cumulative evaluation window starts.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  |
| evaluation_window             | timezone                       | string    | The timezone of the time of the day of the cumulative evaluation window start.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  |
| options                       | silenced                       | object    | **DEPRECATED**: Information about the downtime applied to the monitor. Only shows v1 downtimes.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 |
| additionalProperties          | <any-key>                      | int64     | UTC epoch timestamp in seconds when the downtime for the group expires.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         |
| options                       | synthetics_check_id            | string    | **DEPRECATED**: ID of the corresponding Synthetic check.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        |
| options                       | threshold_windows              | object    | Alerting time window options.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   |
| threshold_windows             | recovery_window                | string    | Describes how long an anomalous metric must be normal before the alert recovers.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                |
| threshold_windows             | trigger_window                 | string    | Describes how long a metric must be anomalous before an alert triggers.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         |
| options                       | thresholds                     | object    | List of the different monitor threshold available.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              |
| thresholds                    | critical                       | double    | The monitor `CRITICAL` threshold.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               |
| thresholds                    | critical_query                 | string    | Query evaluated as a dynamic `CRITICAL` threshold. Only supported on metric monitors with a formula query and options['variables']. Cannot be combined with static thresholds. This field is in preview.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        |
| thresholds                    | critical_recovery              | double    | The monitor `CRITICAL` recovery threshold.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      |
| thresholds                    | critical_recovery_query        | string    | Query evaluated as a dynamic `CRITICAL` recovery threshold. Only supported on metric monitors with a formula query and options['variables']. Cannot be combined with static thresholds. This field is in preview.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               |
| thresholds                    | ok                             | double    | The monitor `OK` threshold.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     |
| thresholds                    | unknown                        | double    | The monitor UNKNOWN threshold.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  |
| thresholds                    | warning                        | double    | The monitor `WARNING` threshold.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                |
| thresholds                    | warning_recovery               | double    | The monitor `WARNING` recovery threshold.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       |
| options                       | timeout_h                      | int64     | The number of hours of the monitor not reporting data before it automatically resolves from a triggered state. The minimum allowed value is 0 hours. The maximum allowed value is 24 hours. Default: `null`.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    |
| options                       | variables                      | [<oneOf>] | List of requests that can be used in the monitor query. **This feature is currently in beta.**                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  |
| variables                     | Object 1                       | object    | A formula and functions events query.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           |
| Object 1                      | compute [*required*]           | object    | Compute options.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                |
| compute                       | aggregation [*required*]       | enum      | Aggregation methods for event platform queries. Allowed enum values: `count`, `cardinality`, `median`, `pc75`, `pc90`, `pc95`, `pc98`, `pc99`, `sum`, `min`, `max`, `avg`.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      |
| compute                       | interval                       | int64     | A time interval in milliseconds.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                |
| compute                       | metric                         | string    | Measurable attribute to compute.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                |
| compute                       | name                           | string    | The name assigned to this aggregation, when multiple aggregations are defined for a query.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      |
| compute                       | source                         | string    | Source reference for composite query payloads.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  |
| Object 1                      | data_source [*required*]       | enum      | Data source for event platform-based queries. Allowed enum values: `rum`, `ci_pipelines`, `ci_tests`, `audit`, `events`, `logs`, `spans`, `database_queries`, `network`, `network_path`, `llm_observability`.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   |
| Object 1                      | group_by                       | [object]  | Group by options.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               |
| group_by                      | facet [*required*]             | string    | Event facet.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    |
| group_by                      | limit                          | int64     | Number of groups to return.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     |
| group_by                      | sort                           | object    | Options for sorting group by results.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           |
| sort                          | aggregation [*required*]       | enum      | Aggregation methods for event platform queries. Allowed enum values: `count`, `cardinality`, `median`, `pc75`, `pc90`, `pc95`, `pc98`, `pc99`, `sum`, `min`, `max`, `avg`.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      |
| sort                          | metric                         | string    | Metric used for sorting group by results.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       |
| sort                          | order                          | enum      | Direction of sort. Allowed enum values: `asc`, `desc`. Default: `desc`.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         |
| group_by                      | source                         | string    | Source reference for composite query payloads.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  |
| Object 1                      | indexes                        | [string]  | An array of index names to query in the stream. Omit or use `[]` to query all indexes at once.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  |
| Object 1                      | name [*required*]              | string    | Name of the query for use in formulas.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          |
| Object 1                      | search                         | object    | Search options.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 |
| search                        | query [*required*]             | string    | Events search string.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           |
| variables                     | Object 2                       | object    | A formula and functions cost query.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             |
| Object 2                      | aggregator                     | enum      | Aggregation methods for metric queries. Allowed enum values: `avg`, `sum`, `max`, `min`, `last`, `area`, `l2norm`, `percentile`, `stddev`.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      |
| Object 2                      | data_source [*required*]       | enum      | Data source for cost queries. Allowed enum values: `cloud_cost`, `datadog_usage`.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               |
| Object 2                      | name [*required*]              | string    | Name of the query for use in formulas.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          |
| Object 2                      | query [*required*]             | string    | The monitor query.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              |
| variables                     | Object 3                       | object    | A formula and functions data quality query.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     |
| Object 3                      | data_source [*required*]       | enum      | Data source for data quality queries. Allowed enum values: `data_quality_metrics`.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              |
| Object 3                      | filter [*required*]            | string    | Filter expression used to match on data entities. Uses Aastra query syntax.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     |
| Object 3                      | group_by                       | [string]  | Optional grouping fields for aggregation.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       |
| Object 3                      | measure [*required*]           | string    | The data quality measure to query. Common values include: `bytes`, `cardinality`, `custom`, `freshness`, `max`, `mean`, `min`, `nullness`, `percent_negative`, `percent_zero`, `row_count`, `stddev`, `sum`, `uniqueness`. `data-jobs alert` job duration monitors use `duration`. Additional values may be supported.                                                                                                                                                                                                                                                                                                                                                                                                                          |
| Object 3                      | monitor_options                | object    | Monitor configuration options for data quality queries.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         |
| monitor_options               | consecutive_runs               | int64     | Number of consecutive runs that must breach before the monitor alerts. Only supported by `data-jobs alert` job duration monitors. Defaults to `1`.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              |
| monitor_options               | crontab_override               | string    | Crontab expression to override the default schedule.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            |
| monitor_options               | custom_sql                     | string    | Custom SQL query for the monitor.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               |
| monitor_options               | custom_where                   | string    | Custom WHERE clause for the query.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              |
| monitor_options               | detection_type                 | enum      | How a `data-jobs alert` job duration monitor detects a breach. Must match the `.detection()` call in the monitor query. Required for job duration monitors. Allowed enum values: `static`, `anomaly`.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           |
| monitor_options               | group_by_columns               | [string]  | Columns to group results by.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    |
| monitor_options               | model_configuration            | object    | Tuning options for the anomaly detection model used by the monitor.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             |
| model_configuration           | auto_resolve_days              | int32     | Number of days after which an open alert is automatically resolved. When unset, alerts stay open until the measure returns within bounds.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       |
[...]
